Attribute VB_Name = "Code39"
' VB / VBA Functions for Code39
' Copyright 2004 by MW6 Technologies Inc. All rights reserved.
'
' This code may not be modified or distributed unless you purchase
' the license from MW6.

Private I As Integer
Private StrLen As Integer
Private Sum As Integer
Private Message As String
Public Function Code39Encode(ByVal Src As String, ByVal CheckDigit As Boolean) As String
    
    Dim tmp As String
    Dim ch As Integer
    
    StrLen = Len(Src)
    tmp = ""
    For I = 1 To StrLen
        ch = Asc(Mid(Src, I, 1))
        If (ch = Asc(" ")) Then
            tmp = tmp & "="
        Else
            tmp = tmp & Chr(ch)
        End If
    Next I
                
    Message = "*" & tmp
    
    If (CheckDigit) Then
        StrLen = Len(Src)
        Sum = 0
        For I = 1 To StrLen
            ch = Asc(Mid(Src, I, 1))
            If ((ch >= Asc("0")) And (ch <= Asc("9"))) Then
                Sum = Sum + ch - Asc("0")
            ElseIf ((ch >= Asc("A")) And (ch <= Asc("Z"))) Then
                Sum = Sum + ch - Asc("A") + 10
            ElseIf (ch = Asc("-")) Then
                Sum = Sum + 36
            ElseIf (ch = Asc(".")) Then
                Sum = Sum + 37
            ElseIf (ch = Asc(" ")) Then
                Sum = Sum + 38
            ElseIf (ch = Asc("=")) Then
                Sum = Sum + 38
            ElseIf (ch = Asc("*")) Then
                Sum = Sum + 39
            ElseIf (ch = Asc("$")) Then
                Sum = Sum + 40
            ElseIf (ch = Asc("/")) Then
                Sum = Sum + 41
            ElseIf (ch = Asc("+")) Then
                Sum = Sum + 42
            ElseIf (ch = Asc("%")) Then
                Sum = Sum + 43
            End If
        Next I
    
        ' add CheckDigit
        Sum = Sum Mod 43
        If (Sum >= 0 And Sum <= 9) Then
            Message = Message & Chr(Sum + Asc("0"))
        ElseIf (Sum >= 10 And Sum <= 35) Then
            Message = Message & Chr(Sum - 10 + Asc("A"))
        ElseIf (Sum = 36) Then
            Message = Message & "-"
        ElseIf (Sum = 37) Then
            Message = Message & "."
        ElseIf (Sum = 38) Then
            Message = Message & "="
        ElseIf (Sum = 39) Then
            Message = Message & "*"
        ElseIf (Sum = 40) Then
            Message = Message & "$"
        ElseIf (Sum = 41) Then
            Message = Message & "/"
        ElseIf (Sum = 42) Then
            Message = Message & "+"
        End If
        
    End If
    
    ' add stop character
    Message = Message & "*"
    
    Code39Encode = Message
    
End Function
